USE Carousel50;
--Can uncomment DROP TABLE if testing
--DROP TABLE IF EXISTS tempdb.dbo.#csltmpchanneltable, tempdb.dbo.#csltmpchanneltable2, tempdb.dbo.#csltmpchanneltable3;
SELECT 
	ChannelName AS Channel,
	ChannelID AS id,
	STUFF((SELECT ',' + CAST(Setup_ChannelBlocks.ZoneID AS VARCHAR) FROM Setup_ChannelBlocks  WHERE Setup_ChannelBlocks.ChannelID = Setup_Channels.ChannelID FOR XML PATH('')), 1 ,1, '') AS 'Zone(s)'
	--Add Zone Ids and Channels in temptable
	INTO #csltmpchanneltable
FROM Setup_Channels;

SELECT
	Channel,
	[Zone(s)],
	STUFF((SELECT ',' + CAST(FullAlert_Subscription.ZoneID AS VARCHAR) 
	FROM FullAlert_Subscription
	WHERE #csltmpchanneltable.id = FullAlert_Subscription.ChannelID
	FOR XML PATH('')), 1 ,1, '') AS 'Full Alert Zone(s)'
	--Build new temp table with full alert IDs added
	INTO #csltmpchanneltable2
FROM #csltmpchanneltable;

--Compare with Zone table and get Names instead of IDs for alerts
SELECT  Channel,
		[Zone(s)],
        STUFF( (  SELECT ','+ CAST(ZoneName AS VARCHAR(8000)) 
                  FROM   Setup_Zones
                  WHERE  ',' + #csltmpchanneltable2.[Full Alert Zone(s)] + ',' LIKE '%,' + CAST(Setup_Zones.ZoneID AS VARCHAR) + ',%'
                  FOR    XML path('')
                , TYPE).value('.', 'VARCHAR(8000)'),1,1,'') 'Full Alert Zone(s)'
	INTO #csltmpchanneltable3
FROM #csltmpchanneltable2;

--Compare with Zone table and get Names instead of IDs for Zones
SELECT  Channel,
        STUFF( (  SELECT ', '+ CAST(ZoneName AS VARCHAR(8000)) 
                  FROM   Setup_Zones
                  WHERE  ',' + #csltmpchanneltable3.[Zone(s)] + ',' LIKE '%,' + CAST(Setup_Zones.ZoneID AS VARCHAR) + ',%'
                  FOR    XML path('')
                , TYPE).value('.', 'VARCHAR(8000)'),1,1,'') 'Zone(s)',
		[Full Alert Zone(s)]
FROM #csltmpchanneltable3;