USE Carousel50;
--Can uncomment DROP TABLE if testing
--DROP TABLE IF EXISTS tempdb.dbo.#csltemptable;
SELECT
	IDENTITY( int ) AS id,
	TagName AS 'Tag Name',
	STUFF((SELECT ',' + CAST(Setup_ZoneTagMapping.ZoneID AS VARCHAR) 
	FROM Setup_ZoneTagMapping  
	WHERE Setup_ZoneTagMapping.TagID = Setup_ZoneTags.TagID 
	FOR XML PATH('')), 1 ,1, '') AS 'Zone(s)'
--Add Zone IDs as a list in Temp table
INTO #csltemptable
FROM Setup_ZoneTags;

--Compare with Zone table and get Names instead of IDs
SELECT  #csltemptable.[Tag Name],
        STUFF( (  SELECT ', '+ CAST(ZoneName AS VARCHAR(8000)) 
                  FROM   Setup_Zones
                  WHERE  ',' + #csltemptable.[Zone(s)] + ',' LIKE '%,' + CAST(Setup_Zones.ZoneID AS VARCHAR) + ',%'
                  FOR    XML path('')
                , TYPE).value('.', 'VARCHAR(8000)'),1,1,'') 'Zone(s)'
FROM #csltemptable;